
__author__ = 'lmstack'
#coding=utf-8
import os
import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
import time, datetime
import dateutil.relativedelta
import traceback
from LIB.MIDDLE.soh import NCMSoh_20210716 as NCMSoh
from urllib import parse
import pymysql
dbManager = DBManager.DBManager()
if __name__ == "__main__":
    
    # 时间设置
    now_time = datetime.datetime.now()
    pre_time = now_time + dateutil.relativedelta.relativedelta(months=-1)#上个月时间
    end_time=datetime.datetime.strftime(now_time,"%Y-%m-%d 01:00:00")
    start_time=datetime.datetime.strftime(pre_time,"%Y-%m-%d 01:00:00")
    # end_time="2021-08-03 01:00:00"
    # start_time="2019-01-01 00:00:00"
    
    # 更新sn列表
    host='rm-bp10j10qy42bzy0q7.mysql.rds.aliyuncs.com'
    port=3306
    db='qixiang_oss'
    user='qixiang_oss'
    password='Qixiang2021'
    conn = pymysql.connect(host=host, port=port, user=user, password=password, database=db)
    cursor = conn.cursor()
    cursor.execute("select sn, imei from app_device")
    res = cursor.fetchall()
    df_sn = pd.DataFrame(res, columns=['sn', 'imei'])
    df_sn = df_sn.reset_index(drop=True)
    conn.close();
    
    # 数据库配置
    host = 'rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
    port = 3306
    user = 'qx_cas'
    password = parse.quote_plus('Qx@123456')
    database = 'qx_cas'

    db_engine = create_engine(
        "mysql+pymysql://{}:{}@{}:{}/{}?charset=utf8".format(
            user, password, host, port, database
        ))
    DbSession = sessionmaker(bind=db_engine)
    
    # 日志配置
    now_str = time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()).replace(":","_")
    log_path = 'log/6040/' + now_str
    if not os.path.exists(log_path):
        os.makedirs(log_path)
    log = Log.Mylog(log_name='soh', log_level = 'info')
    log.set_file_hl(file_name='{}/info.log'.format(log_path), log_level='info', size=1024* 1024 * 100)
    log.set_file_hl(file_name='{}/error.log'.format(log_path), log_level='error', size=1024* 1024 * 100)
    logger = log.get_logger()

    logger.info("pid is {}".format(os.getpid()))
    
    # SNdata_6040 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='6040骑享')
    # SNnums_6040=SNdata_6040['SN号']
    # now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    # now_time = "2021-08-01 00:00:00" # 定时任务开启时，需要删除改行！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！！
    # now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    # start_time=now_time-datetime.timedelta(days=1000)
    # end_time=str(now_time)
    # start_time=str(start_time)

    for i in range(0, len(df_sn)):
        try:
            if df_sn.loc[i, 'imei'][6:9] != '640':
                continue
            sn = df_sn.loc[i, 'sn']
            # if sn in SNnums_6040.tolist():
            #     print(sn)
            #     continue
            logger.info("pid-{} 6040 SN: {} START!".format(os.getpid(), sn))
            res = NCMSoh.cal_soh(sn, end_time, start_time)
            if not res.empty:
                res.columns = ['time', 'sn', 'bms_soh', 'soh', 'soh_err']
                res.to_sql("soh_result",con=db_engine, if_exists="append",index=False)
            logger.info("6040 SN: {} DONE!".format(sn))
        except:
            logger.error(traceback.format_exc)
            logger.error(u"{} ：{},{} 任务运行错误\n".format(sn,start_time,end_time), exc_info=True)

