import CBMSBatSoh
import log
#coding=utf-8
import os
import datetime
import pandas as pd
from LIB.BACKEND import DBManager, Log
# from LIB.MIDDLE import SignalMonitor
from sqlalchemy import create_engine
from sqlalchemy.orm import sessionmaker
import time, datetime
from LIB.MIDDLE.soh import NCMSoh_20210716 as NCMSoh
from LIB.MIDDLE.soh import LFPSoh_20210711 as LFPSoh
from urllib import parse

host='rm-bp10j10qy42bzy0q77o.mysql.rds.aliyuncs.com'
port=3306
db='qx_cas'
user='qx_read'
password='Qx@123456'
tablename='soh_result'

dbManager = DBManager.DBManager()
if __name__ == "__main__":
    SNdata_6040 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='6040骑享')
    SNdata_6060 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='6060')
    SNdata_4840 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='4840骑享')
    SNdata_7250 = pd.read_excel('骑享资产梳理-20210621.xlsx', sheet_name='7250')
    SNnums_6060=SNdata_6060['SN号']
    SNnums_6040=SNdata_6040['SN号']
    SNnums_4840=SNdata_4840['SN号']
    SNnums_7250=SNdata_7250['SN号']

    SNnums=SNnums_6040.tolist()+SNnums_6060.tolist()+SNnums_4840.tolist()
    now_time=datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')
    now_time=datetime.datetime.strptime(now_time,'%Y-%m-%d %H:%M:%S')
    start_time=now_time-datetime.timedelta(days=30)
    end_time=str(now_time)
    start_time=str(start_time)

    #log信息配置
    mylog=log.Mylog('log.txt','error')
    mylog.logcfg()

    for sn in SNnums:
        try:
            dbManager = DBManager.DBManager()
            df_data = dbManager.get_data(sn='PK50001A100000022', start_time=start_time, end_time=end_time, data_groups=['bms','accum'])
            df_bms = df_data['bms']
            df_accum=df_data['accum']
            # df_bms.to_csv('BMS_'+sn+'.csv')
            # df_accum.to_csv('BMS_accum_'+sn+'.csv')

            BatSoh=CBMSBatSoh.BatSoh(sn,df_bms,df_accum,host, port, db, user, password, tablename)
            df_res=BatSoh.batsoh()
            df_res.to_csv('BMS_SOH_'+sn+'.csv',encoding='GB18030')
             
        except IndexError as e:
            print(repr(e))
            mylog.logopt(sn,e)
            pass
